/*
homework #4
correlation problem, an Nbody type program

Kyung-suk Lhee
10/27/98
*/

#include <mpi.h>
#include <stdio.h>
#include <math.h>

#define ALL MPI_COMM_WORLD
#define N 1000

void main(int argc, char **argv) {

  int size, id, i, j, k, lnbr, rnbr, n;
  double *x, *y, correl, gcorrel, buf;
  MPI_Status status;

  MPI_Init(&argc, &argv);
  MPI_Comm_size(ALL, &size);
  MPI_Comm_rank(ALL, &id);

  /* initialize local block */
  n = N / size;
  x = (double*)malloc(sizeof(double) * n);
  y = (double*)malloc(sizeof(double) * n);

  for (i=0; i<n; i++)
    x[i] = y[i] = i + id * n;     /* 0 - 999 */
  correl = 0;

  lnbr = (id - 1 + size) % size;
  rnbr = (id + 1) % size;

  /* compute local correlation */
  for (k=0; k<size; k++) {
    for (j=0; j<n; j++)
      for (i=0; i<n; i++)
        correl += fabs(x[i]*x[i] + y[j]*y[j]);

    MPI_Send(y, n, MPI_DOUBLE, lnbr, 1, ALL);
    MPI_Recv(y, n, MPI_DOUBLE, rnbr, 1, ALL, &status);
  }

  /* global correlation */
  MPI_Reduce(&correl, &gcorrel, 1, MPI_DOUBLE, MPI_SUM, 0, ALL);

  if (id == 0)
    printf("the result is:%g\n", gcorrel);

  MPI_Finalize();
}
